using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Oqtane.Databases.Interfaces;
using Oqtane.Migrations;
using SZUAbsolventenverein.Module.EventRegistration.Migrations.EntityBuilders;
using SZUAbsolventenverein.Module.EventRegistration.Repository;

namespace SZUAbsolventenverein.Module.EventRegistration.Migrations
{
    [DbContext(typeof(EventRegistrationContext))]
    [Migration("SZUAbsolventenverein.Module.EventRegistration.01.00.00.00")]
    public class InitializeModule : MultiDatabaseMigration
    {
        public InitializeModule(IDatabase database) : base(database)
        {
        }

        protected override void Up(MigrationBuilder migrationBuilder)
        {
            var entityBuilder = new EventEntityBuilder(migrationBuilder, ActiveDatabase);
            entityBuilder.Create();

            var entityBuilder2 = new EventResponseEntityBuilder(migrationBuilder, ActiveDatabase);
            entityBuilder2.Create();
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            var entityBuilder = new EventEntityBuilder(migrationBuilder, ActiveDatabase);
            entityBuilder.Drop();
            var entityBuilder2 = new EventResponseEntityBuilder(migrationBuilder, ActiveDatabase);
            entityBuilder2.Drop();
        }
    }
}
