using System;
using System.Collections.Generic;
using System.Threading.Tasks;
using SZUAbsolventenverein.Module.EventRegistration.Models;

namespace SZUAbsolventenverein.Module.EventRegistration.Services
{
    public interface IEventRegistrationService 
    {
        /* Reine Events */
        Task<List<Event>> GetEventsAsync(int ModuleId);
        Task<Event> GetEventAsync(int EventId, int ModuleId);

        Task<Event> AddEventAsync(Event NewEvent);

        Task<Event> UpdateEventAsync(Event NewEvent);

        Task DeleteEventAsync(int EventId, int ModuleId);


        /* Events & Responses */
        Task<Response> AddResponseAsync(Response Response);
        
        Task<Response> UpdateResponseAsync(Response Response);

        Task<(Event, Response)> GetEventDetails(int EventId, int ModuleId);

        Task<List<Response>> GetEventResponses(int EventId, int ModuleId);
    }
}
